unit AlxCommon;

interface
uses
  Windows, Classes, Forms, Graphics, Controls, ExtCtrls, SysUtils;

type
  TSide = ( sdLeft, sdTop, sdRight, sdBottom );
  TSides = set of TSide;
  TFrameStyle = (fsNone, fsFlat, fsRaised, fsLowered);
  TAlignment = (taCenter, taLeftJustify, taRightJustify);
  function DrawSides(Canvas: TCanvas; Bounds: TRect; ULColor,
                     LRColor: TColor; Sides: TSides): TRect;
  function DrawBevel(Canvas: TCanvas; Bounds: TRect; ULColor, LRColor: TColor;
                     Width: Integer; Sides: TSides): TRect;

implementation

{ -  }
function DrawSides(Canvas: TCanvas; Bounds: TRect; ULColor,
                   LRColor: TColor; Sides: TSides ): TRect;
begin
  with Canvas, Bounds do
  begin
    Pen.Color := ULColor;
    if sdLeft in Sides then
    begin
      MoveTo( Left, Top );
      LineTo( Left, Bottom );
    end;

    if sdTop in Sides then
    begin
      MoveTo( Left, Top );
      LineTo( Right, Top );
    end;

    Pen.Color := LRColor;
    if sdRight in Sides then
    begin
      MoveTo( Right - 1, Top );
      LineTo( Right - 1, Bottom );
    end;

    if sdBottom in Sides then
    begin
      MoveTo( Left, Bottom - 1 );
      LineTo( Right, Bottom - 1 );
    end;
  end;

  if sdLeft in Sides then
    Inc( Bounds.Left );
  if sdTop in Sides then
    Inc( Bounds.Top );
  if sdRight in Sides then
    Dec( Bounds.Right );
  if sdBottom in Sides then
    Dec( Bounds.Bottom );

  Result := Bounds;
end; {= DrawSides =}

function DrawBevel( Canvas: TCanvas; Bounds: TRect; ULColor, LRColor: TColor;
                    Width: Integer; Sides: TSides ): TRect;
var
  I: Integer;
begin
  Canvas.Pen.Width := 1;
  for I := 1 to Width do                         { Loop through width of bevel }
  begin
    Bounds := DrawSides( Canvas, Bounds, ULColor, LRColor, Sides );
  end;
  Result := Bounds;
end;

end.
